using Terraria;
using System;
using System.Diagnostics;
using Microsoft.Xna.Framework;

using TAPI; 

namespace CribMod.Items
{
public class TheRemower : ModItem
    {
       	public override void UseItemEffects(Player player, Rectangle rectangle)
	{
		int dustID = Dust.NewDust(new Vector2((float)rectangle.X, (float)rectangle.Y), rectangle.Width, rectangle.Height, 58, (player.velocity.X * 0.2f) + (player.direction * 3), player.velocity.Y * 0.2f, 100, Color.Black, 0.4f + (Main.rand.Next(15) * 0.1f));
		Main.dust[dustID].noGravity = true; 
	}
        public override void DealtNPC(Player owner, NPC npc, int hitDir, int dmgDealt, float knockback, bool crit)
        {
            owner.statLife += 4;
        }
		
		public override void UseStyle(Player p) { UseStyles.SetStyleLow(p, item); } //Grealm
		
			public class UseStyles
	{
		#region low
		public static int[] lowDelay = new int[255];
		public static int[] lowItemRotAnim = new int[255];
		public static bool[] lowState = new bool[255];
		public static void SetStyleLow(Player player, Item item)
		{
			if (!lowState[player.whoAmI]) { lowState[player.whoAmI] = true; player.itemAnimation = (int)((float)item.useAnimation * player.meleeSpeed) * 2; }
			player.itemAnimationMax = (int)((float)item.useAnimation * player.meleeSpeed) * 2;
			int anim = player.itemAnimation;
			int animMax = player.itemAnimationMax;
			if (lowDelay[player.whoAmI] <= 0) { lowDelay[player.whoAmI]++; if (lowDelay[player.whoAmI] >= 0) { lowDelay[player.whoAmI] = 120; } }
			if (lowDelay[player.whoAmI] >= 1 && anim > animMax * 0.5f)
			{
				if (anim == animMax) { lowItemRotAnim[player.whoAmI] = animMax; }
				lowDelay[player.whoAmI]--;
				lowItemRotAnim[player.whoAmI] += 1;
			}else
			{
				lowItemRotAnim[player.whoAmI] -= 4;
				if (lowItemRotAnim[player.whoAmI] < 1) { lowItemRotAnim[player.whoAmI] = 1; }
			}
			player.itemRotation = ((float)lowItemRotAnim[player.whoAmI] * 0.75f / player.itemAnimationMax - 0.5f) * -player.direction * 3.5f - player.direction * 0.3f;
			if (player.gravDir == -1f) { player.itemRotation *= -1; }

			
		}

		#endregion
		
		}

    }
}