using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using TAPI;
using Terraria;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace CribMod.NPCs
{
	public class CometRiderBoss: ModNPC
	{		
		public override void AI()
		{
			if (Main.dayTime) 
			{
                	npc.velocity.X -= 2.11f;
                	if (npc.timeLeft > 60)
                	{
                    	npc.timeLeft = 60;
                    	return;
                	}
		}
            		if (Main.player[npc.target].dead)
            		{
                	npc.velocity.Y -= 1.11f;
                	if (npc.timeLeft > 10)
                	{
                   	npc.timeLeft = 10;
                    	return;
                	}
	    	}
			npc.netUpdate = false;
            npc.ai[1]++;

            if (npc.ai[1] >= 10 && Main.netMode != 1)
                {
                int SkeletronPrimeSpawn = NPC.NewNPC((int)npc.position.X + (npc.width / 2), (int)npc.position.Y + (npc.height / 2), "Vanilla:Skeletron Prime", 0);
                npc.ai[1] = 20 - Main.rand.Next(5000);
                if (Main.netMode == 2 && SkeletronPrimeSpawn < 200)
                {
                    NetMessage.SendData(23, -1, -1, "", SkeletronPrimeSpawn, 0f, 0f, 0f, 0);
                }
                }
			if (npc.ai[3] >= 0)
			{
				if ((Collision.CanHit(npc.position, npc.width, npc.height, Main.player[npc.target].position, Main.player[npc.target].width, Main.player[npc.target].height)))
				{
					float num48 = 1f;
					int damage = 60;
					int type = ProjDef.byName["Vanilla:Frost Wave"].type;
					Main.PlaySound(2, (int) npc.Center.X, (int) npc.Center.Y, 20);
					float rotation = (float) Math.Atan2(npc.Center.Y-(Main.player[npc.target].position.Y+(Main.player[npc.target].height * 0.5f)), npc.Center.X-(Main.player[npc.target].position.X+(Main.player[npc.target].width * 0.5f)));
					if (Main.netMode != -100)
					{
						int num54 = Projectile.NewProjectile(npc.Center.X, npc.Center.Y,(float)((Math.Cos(rotation) * num48)*-1),(float)((Math.Sin(rotation) * num48)*-1), type, damage, 0f, Main.myPlayer);
						Main.projectile[num54].rotation = (float) Math.Atan2(npc.Center.Y-(Main.player[npc.target].position.Y+(Main.player[npc.target].height * 0.5f)), npc.Center.X-(Main.player[npc.target].position.X+(Main.player[npc.target].width * 0.5f)));
						Main.projectile[num54].scale = 0;
						Main.projectile[num54].timeLeft = 420;
					}
					npc.ai[0] = -1-Main.rand.Next(2000);
				}
			}
			
			if (Main.time % 2 == 0 && Main.netMode == 2 && npc.whoAmI < 2000)
			{
				NetMessage.SendData(23, -1, -1, "", npc.whoAmI, 0f, 0f, 0f, 0);
			}
		{
	
			if (npc.velocity.X !=0 || npc.velocity.Y !=0)
            {
                int aura = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 15, Main.rand.Next(-5,5), Main.rand.Next(-5,5), 50, Color.White, 1.5f);
				Main.dust[aura].noGravity = true;
            }

			#region set up NPC's attributes & behaviors
            // set parameters

            //  can_teleport==true code uses boredom_time and ai[3] (boredom), but not mutually exclusive
            bool can_teleport = true;  //  tp around like chaos ele
            int boredom_time = 20; // time until it stops targeting player if blocked etc, 60 for anything but chaos ele, 20 for chaos ele
            int boredom_cooldown = 10 * boredom_time; // boredom level where boredom wears off; usually 10*boredom_time

            // Omnirs creature sorts
            bool tooBig = false; // force bigger creatures to jump
            bool lavaJumping = false; // Enemies jump on lava.

            #endregion
            //-------------------------------------------------------------------


            #region Too Big and Lava Jumping
            if (tooBig)
            {
                if (npc.velocity.Y == 0f && (npc.velocity.X == 0f && npc.direction < 0))
                {
                    npc.velocity.Y -= 8f;
                    npc.velocity.X -= 2f;
                }
                else if (npc.velocity.Y == 0f && (npc.velocity.X == 0f && npc.direction > 0))
                {
                    npc.velocity.Y -= 8f;
                    npc.velocity.X += 2f;
                }
            }
            if (lavaJumping)
            {
                if (npc.lavaWet)
                {
                    npc.velocity.Y -= 2;
                }
            }
            #endregion
            //-------------------------------------------------------------------
          if (can_teleport)
            {
				Vector2 teleportLocation = new Vector2(Main.player[npc.target].position.X+Main.rand.Next(-150,150),Main.player[npc.target].position.Y+Main.rand.Next(-150,150));
				if (teleportLocation.X < 0) teleportLocation.X = 0;
				if (teleportLocation.X > Main.maxTilesX*16) teleportLocation.X = Main.maxTilesX*160;
				if (teleportLocation.Y < 0) teleportLocation.Y = 0;
				if (teleportLocation.Y > Main.maxTilesY*16) teleportLocation.Y = Main.maxTilesY*160;
                		if(	!TileDef.solid[Main.tile[(int)(teleportLocation.X/16),(int)((teleportLocation.Y+npc.width)/16)].type] && 
					!TileDef.solid[Main.tile[(int)((teleportLocation.X/16)+16), (int)((teleportLocation.Y+npc.width)/16)].type] && 
					Main.rand.Next(4) == 0)
					{
						Teleport(teleportLocation.X, teleportLocation.Y);
					}
            }
		}
		}
            //-------------------------------------------------------------------
             
		public void Teleport(float X, float Y)
		{
			int dustDeath = 0;
			for (int num36 = 0; num36 < 20; num36++)
			{
				dustDeath = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 54, Main.rand.Next(-10,10), Main.rand.Next(-10,10), 200, Color.Black, 2f);
				Main.dust[dustDeath].noGravity = true;
			}
			npc.position.X = X;
			npc.position.Y = Y;
			npc.velocity.X = 0;
			npc.velocity.Y = 0;
			for (int num36 = 0; num36 < 20; num36++)
			{
					dustDeath = Dust.NewDust(new Vector2(X, Y), npc.width, npc.height, 54, npc.velocity.X+Main.rand.Next(-10,10), npc.velocity.Y+Main.rand.Next(-10,10), 200, Color.Black, 2f);
					Main.dust[dustDeath].noGravity = true;
			}
		}

		public override void DamagePlayer(Player p, int hitDir, ref int damage, ref bool crit, ref float critChance)
        	{
            			p.AddBuff(33, 3600, false);
        	}
	
   		public override void PostNPCLoot()
        	{				
				Main.NewText("Comet Rider has been defeated!", 175, 75, 255); 
        	}
	}	
}