using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace CribMod.NPCs
{
    public class ProtossCarrierBoss: ModNPC
    {
        public override void AI()
	{
		if (Main.dayTime) 
		{
                	npc.velocity.Y -= 1.11f;
                	if (npc.timeLeft > 10)
                	{
                    	npc.timeLeft = 10;
                    	return;
                	}
		}
	    {
	    npc.netUpdate = false;
            npc.ai[1]++;

            if (npc.ai[1] >= 10 && Main.netMode != 1)
                {
                int InterceptorBossSpawn = NPC.NewNPC((int)npc.position.X + (npc.width / 2), (int)npc.position.Y + (npc.height / 2), "CribMod:InterceptorBoss", 0);
                npc.ai[1] = 20 - Main.rand.Next(200);
                if (Main.netMode == 2 && InterceptorBossSpawn < 200)
                {
                    NetMessage.SendData(23, -1, -1, "", InterceptorBossSpawn, 0f, 0f, 0f, 0);
                }

			if (npc.velocity.X !=0 || npc.velocity.Y !=0)
            {
                int aura = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 68, Main.rand.Next(-1,1), Main.rand.Next(-1,1), 50, Color.Blue, 3.5f);
				Main.dust[aura].noGravity = true;
            }
       			// if the target is dead, slow down and despawn in 1/6th of a second
            		if (Main.player[npc.target].dead)
            		{
                		npc.velocity.Y -= 0.04f;
                		if (npc.timeLeft > 10)
                		{
                    		npc.timeLeft = 10;
                    		return;
                		}
	    		}
		}		
	    }
	}

	public override void SelectFrame(int frameSize)
	{
			int num = 1;
			if (!Main.dedServ)
			{
				num = Main.npcTexture[npc.type].Height / Main.npcFrameCount[npc.type];
			}
			if (npc.position.X < Main.player[npc.target].position.X)
			{
				npc.spriteDirection = -1;
			}
			else
			{
				npc.spriteDirection = 1;
			}
			npc.rotation = npc.velocity.X * 0.08f;
			npc.frameCounter += 1.0;
			if (npc.frameCounter >= 4.0)
			{
				npc.frame.Y = npc.frame.Y + num;
				npc.frameCounter = 0.0;
			}
			if (npc.frame.Y >= num * Main.npcFrameCount[npc.type])
			{
				npc.frame.Y = 0;
			}
	}
		
   	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
				if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 16, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
				npc.soundHit = 0; npc.soundKilled = 14;
				for (int i = 0; i < 25; i++)
				{
					int dustID = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 31, 0f, 0f, 100, default(Color), 2f);
					Main.dust[dustID].velocity *= 1.4f;
					Main.dust[dustID].noLight = true;
					Main.dust[dustID].noGravity = true;
				}
				int goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				}
			}
	}

   	public override void PostNPCLoot()
        {				
				Main.NewText("Protoss Carrier has been defeated!", 175, 75, 255); 
        }
    }
}