using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace CribMod.NPCs
{
    public class QuadCannonBoss: ModNPC
    {
   	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
				if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 1, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
				npc.soundHit = 0; npc.soundKilled = 14;
				for (int i = 0; i < 25; i++)
				{
					int dustID = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 31, 0f, 0f, 100, default(Color), 2f);
					Main.dust[dustID].velocity *= 1.4f;
					Main.dust[dustID].noLight = true;
					Main.dust[dustID].noGravity = true;
				}
				int goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:QuadCannonGore1"], 1f);	
				Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:QuadCannonGore2"], 1f);	
				Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:QuadCannonGore3"], 1f);
				Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:QuadCannonGore4"], 1f);	
				Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:QuadCannonGore5"], 1f);
				}
			}
	}

	public override void AI()
	{
                        if (Main.rand.Next(150) == 1)
                        {
                            float num48 = 8f;
                            Vector2 vector8 = new Vector2(npc.position.X + (npc.width * 0.5f), npc.position.Y + (npc.height / 2));
                            float speedX = ((Main.player[npc.target].position.X + (Main.player[npc.target].width * 0.5f)) - vector8.X) + Main.rand.Next(-20, 0x15);
                            float speedY = ((Main.player[npc.target].position.Y + (Main.player[npc.target].height * 0.5f)) - vector8.Y) + Main.rand.Next(-20, 0x15);
                            if (((speedX < 0f) && (npc.velocity.X < 0f)) || ((speedX > 0f) && (npc.velocity.X > 0f)))
                            {
                                Main.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, 5);
                                float num51 = (float)Math.Sqrt((double)((speedX * speedX) + (speedY * speedY)));
                                num51 = num48 / num51;
                                speedX *= num51;
                                speedY *= num51;
                                int damage = 150,
                                type = ProjDef.byName["Vanilla:Missile"].type;
                                int num54 = Projectile.NewProjectile(vector8.X, vector8.Y, speedX, speedY, type, damage, 0f, Main.myPlayer);
				Main.projectile[num54].scale = 2;
                                Main.projectile[num54].timeLeft = 1000;
                            }
                            npc.netUpdate = true;
                        }
                        if (Main.rand.Next(160) == 1)
                        {
                            float num48 = 8f;
                            Vector2 vector8 = new Vector2(npc.position.X + (npc.width * 0.5f), npc.position.Y + (npc.height / 2));
                            float speedX = ((Main.player[npc.target].position.X + (Main.player[npc.target].width * 0.1f)) - vector8.X) + Main.rand.Next(-20, 0x15);
                            float speedY = ((Main.player[npc.target].position.Y + (Main.player[npc.target].height * 0.1f)) - vector8.Y) + Main.rand.Next(-20, 0x15);
                            if (((speedX < 0f) && (npc.velocity.X < 0f)) || ((speedX > 0f) && (npc.velocity.X > 0f)))
                            {
                                Main.PlaySound(2, (int)npc.position.X, (int)npc.position.Y, 5);
                                float num51 = (float)Math.Sqrt((double)((speedX * speedX) + (speedY * speedY)));
                                num51 = num48 / num51;
                                speedX *= num51;
                                speedY *= num51;
                                int damage = 499,
                                type = ProjDef.byName["CribMod:AntimatterBall"].type;
                                int num54 = Projectile.NewProjectile(vector8.X, vector8.Y, speedX, speedY, type, damage, 0f, Main.myPlayer);
				Main.projectile[num54].scale = 1;
                                Main.projectile[num54].timeLeft = 1000;
                            }
                            npc.netUpdate = true;
                        }
						if (Main.player[npc.target].dead)
						{
						npc.velocity.Y -= 1.11f;
						if (npc.timeLeft > 10)
						{
						npc.timeLeft = 10;
						return;
						}
						}
			
			if (Main.time % 2 == 0 && Main.netMode == 2 && npc.whoAmI < 2000)
			{
				NetMessage.SendData(23, -1, -1, "", npc.whoAmI, 0f, 0f, 0f, 0);
			}

            npc.TargetClosest(true);

            #region set up NPC's attributes & behaviors
            // set parameters
            bool hates_light = false;  //  flees in daylight like: Zombie, Skeleton, Undead Miner, Doctor Bones, The Groom, Werewolf, Clown, Bald Zombie, Possessed Armor

            int sound_type = 7; // Parameter for Main.PlaySound().  14 for Zombie, Skeleton, Angry Bones, Heavy Skeleton, Skeleton Archer, Bald Zombie.  26 for Mummy, Light & Dark Mummy. 0 means no sounds
            int sound_frequency = 500;  //  chance to play sound every frame, 1000 for zombie/skel, 500 for mummies

            // Omnirs creature sorts
            bool tooBig = false; // force bigger creatures to jump
            bool lavaJumping = false; // Enemies jump on lava.

            #endregion
            //-------------------------------------------------------------------

            #region Too Big and Lava Jumping
            if (tooBig)
            {
                if (npc.velocity.Y == 0f && (npc.velocity.X == 0f && npc.direction < 0))
                {
                    npc.velocity.Y -= 16f;
                    npc.velocity.X -= 2f;
                }
                else if (npc.velocity.Y == 0f && (npc.velocity.X == 0f && npc.direction > 0))
                {
                    npc.velocity.Y -= 16f;
                    npc.velocity.X += 2f;
                }
            }
            if (lavaJumping)
            {
                if (npc.lavaWet)
                {
                    npc.velocity.Y -= 2;
                }
            }
            #endregion
            //-------------------------------------------------------------------

            #region play creature sounds, target/face player, respond to boredom
            {   // not fleeing light & not bored
                if (sound_type > 0 && Main.rand.Next(sound_frequency) <= 0)
                    Main.PlaySound(sound_type, (int)npc.position.X, (int)npc.position.Y, 1); // random creature sounds
            }
            #endregion

            //-------------------------------------------------------------------
	}

   	public override void PostNPCLoot()
        {				
			Main.NewText("Quad Cannon has been defeated!", 175, 75, 255); 

			if(Main.rand.Next(3) == 0)
			{
			Main.NewText("Does not compute.", 249, 249, 9);
			}else
			if(Main.rand.Next(3) == 0)
			{
			Main.NewText("System failure.", 249, 249, 9);
			}else
			if(Main.rand.Next(3) == 0)
			{
			Main.NewText("You got lucky this time.", 249, 249, 9);
			}else
			if(Main.rand.Next(3) == 0)
			{
			Main.NewText("NEEEEEERRD.", 249, 249, 9);
			}else
			{
                	Main.NewText("Beep boop. Not fair.", 249, 249, 9);
			}
        }
    }
}