using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using TAPI;
using Terraria;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace CribMod.NPCs
{
    public class SwordPlayBoss: ModNPC
    {				
        public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
				if (Main.netMode != 2)
		{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
				npc.soundHit = 0; npc.soundKilled = 14;
				for (int i = 0; i < 25; i++)
				{
					int dustID = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 31, 0f, 0f, 100, default(Color), 2f);
					Main.dust[dustID].velocity *= 1.4f;
					Main.dust[dustID].noLight = true;
					Main.dust[dustID].noGravity = true;
				}
				int goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				}
		}
	}

	public override void AI()
	{
			if (Main.rand.Next(2)==0)
			{
				int dust = Dust.NewDust(new Vector2((float) npc.position.X, (float) npc.position.Y), npc.width, npc.height, 6, npc.velocity.X, npc.velocity.Y, 200, Color.White, 1f);
				Main.dust[dust].noGravity = false;
			}


			if (npc.ai[3] >= 31000)
			{
				if ((Collision.CanHit(npc.position, npc.width, npc.height, Main.player[npc.target].position, Main.player[npc.target].width, Main.player[npc.target].height)))
				{
					float num48 = 1f;
					int damage = 110;
					int type = ProjDef.byName["Vanilla:Death Laser"].type;
					Main.PlaySound(2, (int) npc.Center.X, (int) npc.Center.Y, 15);
					float rotation = (float) Math.Atan2(npc.Center.Y-(Main.player[npc.target].position.Y+(Main.player[npc.target].height * 0.5f)), npc.Center.X-(Main.player[npc.target].position.X+(Main.player[npc.target].width * 0.5f)));
					if (Main.netMode != -100)
					{
						int num54 = Projectile.NewProjectile(npc.Center.X, npc.Center.Y,(float)((Math.Cos(rotation) * num48)*-1),(float)((Math.Sin(rotation) * num48)*-1), type, damage, 0f, Main.myPlayer);
						Main.projectile[num54].rotation = (float) Math.Atan2(npc.Center.Y-(Main.player[npc.target].position.Y+(Main.player[npc.target].height * 0.5f)), npc.Center.X-(Main.player[npc.target].position.X+(Main.player[npc.target].width * 0.5f)));
						Main.projectile[num54].scale = 3;
						Main.projectile[num54].timeLeft = 1200;
					}
					npc.ai[0] = -1-Main.rand.Next(1);
				}
			}
						if (Main.player[npc.target].dead)
						{
						npc.velocity.X -= 2.11f;
						if (npc.timeLeft > 10)
						{
						npc.timeLeft = 10;
						return;
						}
						}
			
			if (Main.time % 2 == 0 && Main.netMode == 2 && npc.whoAmI < 2000)
			{
				NetMessage.SendData(23, -1, -1, "", npc.whoAmI, 0f, 0f, 0f, 0);
			}
            {
				Vector2 teleportLocation = new Vector2(Main.player[npc.target].position.X+Main.rand.Next(-150,150),Main.player[npc.target].position.Y+Main.rand.Next(-150,150));
				if (teleportLocation.X < 0) teleportLocation.X = 0;
				if (teleportLocation.X > Main.maxTilesX*16) teleportLocation.X = Main.maxTilesX*16;
				if (teleportLocation.Y < 0) teleportLocation.Y = 0;
				if (teleportLocation.Y > Main.maxTilesY*16) teleportLocation.Y = Main.maxTilesY*16;
                		if(	!TileDef.solid[Main.tile[(int)(teleportLocation.X/16),(int)((teleportLocation.Y+npc.width)/16)].type] && 
					!TileDef.solid[Main.tile[(int)((teleportLocation.X/16)+16), (int)((teleportLocation.Y+npc.width)/16)].type] && 
					Main.rand.Next(2) == 0)
					{
						Teleport(teleportLocation.X, teleportLocation.Y);
					}
            }
	}

	public void Teleport(float X, float Y)
	{
			int dustDeath = 0;
			for (int num36 = 0; num36 < 20; num36++)
			{
				dustDeath = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 54, Main.rand.Next(-10,10), Main.rand.Next(-10,10), 200, Color.Black, 2f);
				Main.dust[dustDeath].noGravity = true;
			}
			npc.position.X = X;
			npc.position.Y = Y;
			npc.velocity.X = 0;
			npc.velocity.Y = 0;
			for (int num36 = 0; num36 < 20; num36++)
			{
					dustDeath = Dust.NewDust(new Vector2(X, Y), npc.width, npc.height, 54, npc.velocity.X+Main.rand.Next(-10,10), npc.velocity.Y+Main.rand.Next(-10,10), 200, Color.Black, 2f);
					Main.dust[dustDeath].noGravity = true;
			}
	}		

   	public override void PostNPCLoot()        
        {				
			Main.NewText("Sword Play has been defeated!", 175, 75, 255); 
        }
    }		
}