using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace CribMod.NPCs
{
    public class NarwhalC: ModNPC
    {
        public override bool CanSpawn(int x, int y, int type, Player player)
        {
  		bool avoids_town=true;
		if (Main.rand.Next(8) != 0) { return false; }
		return Main.raining && Main.hardMode && player.zone["Ocean"];
        }

   	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
				if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 2f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
				for (int i = 0; i < 25; i++)
				{
					int dustID = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 5, 0f, 0f, 100, default(Color), 2f);
					Main.dust[dustID].velocity *= 1.4f;
					Main.dust[dustID].noLight = true;
					Main.dust[dustID].noGravity = true;
				}
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:NarwhalGore0"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:NarwhalGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:NarwhalGore2"], 1f);
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:NarwhalGore3"], 1f);	
				}
			}
	}

	public override void SelectFrame(int frameSize)
	{
			int num = 1;
			if (!Main.dedServ)
			{
				num = Main.npcTexture[npc.type].Height / Main.npcFrameCount[npc.type];
			}
			if (npc.position.X < Main.player[npc.target].position.X)
			{
				npc.spriteDirection = -1;
			}
			else
			{
				npc.spriteDirection = 1;
			}
			npc.rotation = npc.velocity.X * 0.08f;
			npc.frameCounter += 1.0;
			if (npc.frameCounter >= 4.0)
			{
				npc.frame.Y = npc.frame.Y + num;
				npc.frameCounter = 0.0;
			}
			if (npc.frame.Y >= num * Main.npcFrameCount[npc.type])
			{
				npc.frame.Y = 0;
			}
	}

	public override void DamagePlayer(Player p, int hitDir, ref int damage, ref bool crit, ref float critChance)
        {
            	p.AddBuff(31, 180, false);
        }

	public override void AI()
	{
		{
                	int aura = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 80, Main.rand.Next(-5,5), Main.rand.Next(-5,5), 50, default(Color), 0.8f);
			Main.dust[aura].noGravity = true;
            	}

            	if (Main.player[npc.target].dead)
            	{
                npc.velocity.Y -= -0.05f;
                if (npc.timeLeft > 10)
                	{
                    	npc.timeLeft = 10;
                    	return;
                	}
	    	}
	}
    }
}