using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Terraria;
using TAPI;

namespace CribMod.NPCs
{
    public class HungryBloodZombie: ModNPC
    {
        public override bool CanSpawn(int x, int y, int type, Player player)
        {
            	if (Main.pumpkinMoon || Main.snowMoon || player.townNPCs > 0f || player.zone["Dungeon"] || player.zone["Jungle"] || player.zone["Snow"] || player.zone["Ocean"] || player.zone["Meteor"]) return false;   
            	if ((Main.bloodMoon && Main.hardMode && player.zone["Surface"]) && Main.rand.Next(3) != 0) return true;
            	{
                return false;
            	}   	
        }

   	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
				if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 2f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
				for (int i = 0; i < 25; i++)
				{
					int dustID = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 5, 0f, 0f, 100, default(Color), 2f);
					Main.dust[dustID].velocity *= 1.4f;
					Main.dust[dustID].noLight = true;
					Main.dust[dustID].noGravity = true;
				}
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:HungryBloodZombie1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:HungryBloodZombie2"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:HungryBloodZombie3"], 1f);
				}
			}
	}

	public override void DamagePlayer(Player p, int hitDir, ref int damage, ref bool crit, ref float critChance)
        {
		if (Main.rand.Next(4)==0)
		{
            	p.AddBuff(30, 3600, false);
		}
        }

	public override void AI()
	{
		{
                	int aura = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 5, Main.rand.Next(-5,5), Main.rand.Next(-5,5), 50, default(Color), 1.1f);
			Main.dust[aura].noGravity = true;
            	}

            	if (Main.player[npc.target].dead)
            	{
                npc.velocity.X -= -0.05f;
                if (npc.timeLeft > 10)
                	{
                    	npc.timeLeft = 10;
                    	return;
                	}
	    	}
	}
    }
}