using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using Terraria;
using TAPI;

namespace CribMod
{
    public class OversizedBoneSerpentBody : ModNPC
    {
        public override void AI()
        {
            if (!Main.npc[(int)npc.ai[1]].active)
            {
                npc.life = 0;
                npc.HitEffect(0, 10.0);
                npc.active = false;
            }
            if (npc.position.X > Main.npc[(int)npc.ai[1]].position.X)
            {
                npc.spriteDirection = 1;
            }
            if (npc.position.X < Main.npc[(int)npc.ai[1]].position.X)
            {
                npc.spriteDirection = -1;
            }
        }

	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
		if (Main.netMode != 2)
		{
			for (int m = 0; m < (isDead ? 20 : 5); m++)
			{
				int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 26, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 3f : 1f);
				if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
			}
			if (isDead)
			{
				Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:OversizedBoneSerpentBodyGore"], 1f);					
			}
		}
	}
    }
}