using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using Terraria;
using TAPI;

namespace CribMod
{
    public class OversizedBoneSerpentHeadBoss : ModNPC
    {
        public override void AI()
        {
            bool TailSpawned = false;

            if (!TailSpawned)
            {
                int Previous = npc.whoAmI;
                for (int Counter = 0; Counter < 20; Counter++)
                {
                    int spawn = 0;
                    if (Counter < 19)
                    {
                        spawn = NPC.NewNPC((int)npc.position.X + (npc.width / 2), (int)npc.position.Y + (npc.height / 2), NPCDef.byName["CribMod:OversizedBoneSerpentBody"].type, npc.whoAmI);
                    }
                    else
                    {
                        spawn = NPC.NewNPC((int)npc.position.X + (npc.width / 2), (int)npc.position.Y + (npc.height / 2), NPCDef.byName["CribMod:OversizedBoneSerpentTail"].type, npc.whoAmI);
                    }
                    Main.npc[spawn].realLife = npc.whoAmI;
                    Main.npc[spawn].ai[2] = (float)npc.whoAmI;
                    Main.npc[spawn].ai[1] = (float)Previous;
                    Main.npc[Previous].ai[0] = (float)spawn;
                    NetMessage.SendData(23, -1, -1, "", spawn, 0f, 0f, 0f, 0);
                    Previous = spawn;
                }
                TailSpawned = true;
            }
            	    if (Main.player[this.npc.target].dead && this.npc.timeLeft > 10)
            	    {
                	this.npc.timeLeft = 10;
            	    }
		    if (Main.rand.Next(2)==0)
		    {
			int dust = Dust.NewDust(new Vector2((float) npc.position.X, (float) npc.position.Y), npc.width, npc.height, 26, npc.velocity.X, npc.velocity.Y, 100, default(Color), 1.4f);
			Main.dust[dust].noGravity = false;
		    }
        }
		
	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
			if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 26, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:OversizedBoneSerpentHeadGore"], 1f);
				}
			}
	}
   		
	public override void PostNPCLoot()    
        {				
			Main.NewText("Oversized Bone Serpent has been defeated!", 175, 75, 255); 
        }
    }
}