using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using Terraria;
using TAPI;

namespace CribMod
{
    public class OversizedBoneSerpentTail : ModNPC
    {
        public override void AI()
        {
            if (!Main.npc[(int)npc.ai[1]].active)
            {
                npc.life = 0;
                npc.HitEffect(0, 10.0);
                npc.active = false;
            }
            if (npc.position.X > Main.npc[(int)npc.ai[1]].position.X)
            {
                npc.spriteDirection = 1;
            }
            if (npc.position.X < Main.npc[(int)npc.ai[1]].position.X)
            {
                npc.spriteDirection = -1;
            }
		if (Main.rand.Next(2)==0)
		{
		int dust = Dust.NewDust(new Vector2((float) npc.position.X, (float) npc.position.Y), npc.width, npc.height, 26, npc.velocity.X, npc.velocity.Y, 100, default(Color), 0.9f);
		Main.dust[dust].noGravity = false;
		}
		{
                    int Spawned = NPC.NewNPC((int)npc.Center.X, (int)npc.Center.Y, "Vanilla:Bone Serpent Head", 0);
                    Main.npc[Spawned].velocity.Y = -8;
                    Main.npc[Spawned].velocity.X = Main.rand.Next(-10, 10) / 10;
                    npc.ai[0] = 10 - Main.rand.Next(70);                  
                }
        }

		public override void HitEffect(int hitDirection, double damage, bool isDead)
		{
			if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 26, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:OversizedBoneSerpentTailGore"], 1f);										
				}
			}
		}
    }
}