using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using Terraria;
using TAPI;

namespace CribMod
{
    public class FortifiedEaterofWorldsTail : ModNPC
    {
        public override void AI()
        {
            //Code help by Yoraiz0r. 

            int toFollowSlot = 1;

            bool shouldSuicide = false;

            if (npc.ai[toFollowSlot] < 0 || npc.ai[toFollowSlot] > Main.maxNPCs || !Main.npc[(int)npc.ai[toFollowSlot]].active)
                shouldSuicide = true;

            #region Suicide on realLife depletion
            if (shouldSuicide)
            {
                npc.life = 0;
                npc.active = false;
                npc.HitEffect(0, 9999); 
                return;
            }
            #endregion

            #region Living AI

            NPC toFollow = Main.npc[(int)npc.ai[toFollowSlot]];
            npc.rotation = npc.DirectionTo(toFollow.Centre).ToRotation() + MathHelper.PiOver2;
            float distancing = 64f * npc.scale;
            Vector2 offsetting = npc.DirectionFrom(toFollow.Centre) * distancing;

            npc.velocity = Vector2.Zero;
            npc.Center = toFollow.Center + offsetting;
            #endregion
		if (Main.rand.Next(2)==0)
		{
		int dust = Dust.NewDust(new Vector2((float) npc.position.X, (float) npc.position.Y), npc.width, npc.height, 18, npc.velocity.X, npc.velocity.Y, 100, default(Color), 0.9f);
		Main.dust[dust].noGravity = false;
		}
        }

		public override void HitEffect(int hitDirection, double damage, bool isDead)
		{
			if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 18, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsHeadGore1"], 1f);
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsHeadGore2"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore2"], 1f);
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore2"], 1f);						
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore2"], 1f);
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore2"], 1f);
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore2"], 1f);
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsBodyGore2"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsTailGore1"], 1f);	
					Gore.NewGore(npc.position, npc.velocity, GoreDef.gores["CribMod:FortifiedEaterofWorldsTailGore2"], 1f);				
				}
			}
		}
    }
}