using System;
using System.Diagnostics;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace CribMod.NPCs
{
    public class CBuddy : ModNPC
    {
		public override void HitEffect(int hitDirection, double damage, bool isDead)
		{
			if (Main.netMode != 2)
			{
				for (int m = 0; m < (isDead ? 20 : 5); m++)
				{
					int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 5, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, Color.White, isDead && m % 2 == 0 ? 3f : 1f);
					if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
				}
				if (isDead)
				{
				npc.soundHit = 0; npc.soundKilled = 0;
				for (int i = 0; i < 25; i++)
				{
					int dustID = Dust.NewDust(new Vector2(npc.position.X, npc.position.Y), npc.width, npc.height, 31, 0f, 0f, 100, default(Color), 2f);
					Main.dust[dustID].velocity *= 1.4f;
					Main.dust[dustID].noLight = true;
					Main.dust[dustID].noGravity = true;
				}
				int goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y += 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X += 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				goreID = Gore.NewGore(new Vector2(npc.position.X + (float)(npc.width / 2) - 24f, npc.position.Y + (float)(npc.height / 2) - 24f), default(Vector2), Main.rand.Next(61, 64), 1f);
				Main.gore[goreID].scale = 1f;
				Main.gore[goreID].velocity.X -= 1f;
				Main.gore[goreID].velocity.Y -= 1f;
				}
			}
		}

        public override string SetName()
        {
            int rand = Main.rand.Next(15);
            string name = "";
            switch(rand)
            {
                case 0: name = "Benette"; break;
                case 1: name = "Crypt"; break;
                case 2: name = "Creep"; break;
                case 3: name = "Eleanor"; break;
                case 4: name = "Feanor"; break;
                case 5: name = "Kaiser Ludwig"; break;
                case 6: name = "Alice"; break;
                case 7: name = "Y Omi"; break;
                case 8: name = "Yew"; break;
                case 9: name = "Ziggy"; break;
                case 10: name = "Ruined"; break;
                case 11: name = "Hazard"; break;
                case 12: name = "Sun Stealer"; break;
                case 13: name = "Jormungand"; break;
                default: name = "Buddy"; break;
            }
            return name;
        }

        public override string SetChat() 
        {
            int rand = Main.rand.Next(5);
            string text = "";
            switch (rand)
            {
                case 0: text = "Hiya! :D"; break;
                case 1: text = "I'll eat your face off."; break;
                case 2: text = "Wanna go stare at a wall with me?"; break;
                case 3: text = "More weapons to come."; break;
                case 4: text = "Hello there kind gentle folk of the living kind. I er..."; break;
            }
		if (Main.rand.Next(3) != 0) 
		{
                                if(NPC.downedBoss1 && Main.rand.Next(9) == 0)
				{
				text = "Butt buddies for life.";
				}else
                                if(NPC.downedBoss2 && Main.rand.Next(9) == 0)
				{
				text = "Every gold earned shall be contributed to the betterment of my stick army.";
				}else
				if (NPC.downedGoblins && Main.rand.Next(8) == 0)
				{
				text = "Tssk tsk. Buyin' n sellin'.";
				}else
  				if(NPC.downedQueenBee && Main.rand.Next(8) == 0)
				{
				text = "Check out my weapons, they're a keeper. Ba dum tssh!";
				}else
  				if(Main.hardMode && Main.rand.Next(10) == 0)
				{
				text = "Hate, malice, I anticipate them. You however, I did not.";
				}else
  				if(Main.hardMode && Main.rand.Next(8) == 0)
				{
				text = "My very existence is highly improbable but you, you are real and alive. Now get out there and get them gold!";
				}else
  				if(Main.hardMode && Main.rand.Next(8) == 0)
				{
				text = "Surely, you dope. You have to buy my stuff.";
				}else
				if (NPC.downedMechBoss1 && Main.rand.Next(4) == 1)
				{
				text = "Well, what we will need here is a sword crafted from the foulest abyss, the dysentery.";
				}else
				if (NPC.downedMechBoss2 && Main.rand.Next(4) == 1)
				{
				text = "Why hold it in when you can let it out? Let 'er rip and let fly the dogs of war!";
				}else
				if (NPC.downedMechBoss3 && Main.rand.Next(4) == 1)
				{
				text = "Some of my wares came from very dead orphans. That's right. You got nothing on me.";
				}else
				if (NPC.downedPlantBoss && Main.rand.Next(4) == 1)
				{
				text = "Don't you dare use that discount card on me.";
				}else
				if (NPC.downedGolemBoss && Main.rand.Next(4) == 1)
				{
				text = "There are unimaginable horrors in this world that will break you. Do be safe and take care.";
				}else
				if (Main.bloodMoon && Main.rand.Next(2) == 0)
				{
				text = "Who dat!? Oh. It's just you. I beseech thee dearest not to jump on me like that.";
				}else
				if (Main.bloodMoon && Main.rand.Next(2) == 0)
				{
				text = "In a night like this, I might consider cutting you down in half!";
				}else
				if(Main.bloodMoon && Main.rand.Next(2) == 0)
				{
				text = "Of all the souls roaming this world. What more are you than mere flesh? Begotten lost cause, sullying your chances... BEGONE I'LL SAY! BEGONE!";
				}else	
				if (NPC.AnyNPCs("Vanilla:Old Man") && Main.rand.Next(4) == 1)
				{
				text = "Respect the old man. They guard dungeons.";
				}
			}
            return text;
        }

        public override void SetupShop(Chest chest, ref int index) 
	{
	if(currentShop == 0)
        {
            chest.item[index].SetDefaults("CribMod:WoodenTotemC"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:OnePike"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:ToyMalletC"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:Tinkerer'sHammerC"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:CGlassSword"); 
            index++;
            chest.item[index].SetDefaults("CribMod:DoorofPain"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:GoldenGlockC"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:ImmolationSwordC"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:NuclearRodC"); 
            index++;
	    chest.item[index].SetDefaults("CribMod:RocketBunnyStaff"); 
            index++;

        if(NPC.downedBoss3)
        { 
	    chest.item[index].SetDefaults("CribMod:DiscardedGunC"); 
            index++;
			}
			
        if(Main.hardMode)
        { 
	    chest.item[index].SetDefaults("CribMod:HuntingCarbineC");
            index++;
            chest.item[index].SetDefaults(1309); 
            index++;
	    chest.item[index].SetDefaults("CribMod:ChoppingAxeC");
            index++;
	    chest.item[index].SetDefaults("CribMod:IronTotemC");
            index++;
            chest.item[index].SetDefaults("CribMod:DungeonCleaverC");
            index++;
            chest.item[index].SetDefaults("CribMod:HolySwordExcalibur");
            index++;
            chest.item[index].SetDefaults("CribMod:TheTaser");
            index++;
            chest.item[index].SetDefaults("CribMod:GlassCannonC");
            index++;
            chest.item[index].SetDefaults("CribMod:ChaosStormStaffC");
            index++;
            chest.item[index].SetDefaults("CribMod:NetofPiranhas");
            index++;
            chest.item[index].SetDefaults("CribMod:GravityStaffC");
            index++;
            chest.item[index].SetDefaults("CribMod:VampiricDefenderC");
            index++;
			}

        if(NPC.downedMechBoss1)
        { 
	    chest.item[index].SetDefaults("CribMod:TacticalDestroyerBall");
            index++;
			}
					
        if(NPC.downedPlantBoss)
        { 
	    chest.item[index].SetDefaults("CribMod:DecapitationBladeC");
            index++;
	    chest.item[index].SetDefaults("CribMod:AccursedSwordC");
            index++;
            chest.item[index].SetDefaults("CribMod:Santank'sGift");
            index++;
            chest.item[index].SetDefaults("CribMod:PepperboxReloaded");
            index++;
            chest.item[index].SetDefaults("CribMod:CPiranhaShotgun");
            index++;
            chest.item[index].SetDefaults("CribMod:StaffofDoubleRainbowC");
            index++;
	    chest.item[index].SetDefaults("CribMod:FrostGiantGreatBowC");
            index++;
	    chest.item[index].SetDefaults("CribMod:VictoryTrainingSpear");
            index++;
			}

        if(Main.bloodMoon)
        { 
	    chest.item[index].SetDefaults("CribMod:CLordDrum");
            index++;
			}		
		}

	else
        {
            chest.item[index].SetDefaults("CribMod:StrandsofHay"); 
            index++;
            chest.item[index].SetDefaults("CribMod:CSlimeCrown"); 
            index++;

	if(NPC.downedBoss3)
	{
	    chest.item[index].SetDefaults("CribMod:CMastersBone");
            index++;
			}

	if(Main.hardMode)
	{
	    chest.item[index].SetDefaults("CribMod:SacrificialMeatCake");
            index++;
			}

	if(NPC.downedMechBossAny)
	{
	    chest.item[index].SetDefaults("CribMod:GrannySmithC");
            index++;
	    chest.item[index].SetDefaults("CribMod:ExpiredPotato");
            index++;
	    chest.item[index].SetDefaults("CribMod:AncientSharkSlab");
            index++;
			}

        if(NPC.downedPlantBoss)
        { 
	    chest.item[index].SetDefaults("CribMod:GlassEyeC");
            index++;
	    chest.item[index].SetDefaults("CribMod:MechanicalPotatoII");
            index++;
	    chest.item[index].SetDefaults("CribMod:DragonBloodChaliceC");
            index++;
			}

        if(Main.bloodMoon)
        { 
	    chest.item[index].SetDefaults("CribMod:HelmofaKnightC");
            index++;
			}

        if(Main.eclipse)
        { 
	    chest.item[index].SetDefaults("CribMod:DerpyChallengedCup");
            index++;
	    chest.item[index].SetDefaults("CribMod:IcySlurpC");
            index++;
	    chest.item[index].SetDefaults("CribMod:EyeOfDeathC");
            index++;
	    chest.item[index].SetDefaults("CribMod:SugarCubeC");
            index++;
	    chest.item[index].SetDefaults("CribMod:MerrymakingHorn");
            index++;
			}
		}
        }

        public override bool ResetShop(Chest chest) { return true; }

        public override void SetChatButtons(ref string[] buttons) //you can have up to 5 buttons (0-4)
	{
			buttons[0] = "Shop";
			buttons[1] = "Fight";
	}
	public override void OnChatButtonClicked(string[] buttons, int buttonIndex, ref bool openShop)
	{
			if (buttonIndex == 0) //Shop buttons can return simply set 'openShop' to true.
			{
				currentShop = 0;
			}else
			if (buttonIndex == 1) 
			{
				currentShop = 1;
			}
			openShop = true;
	}

	public byte currentShop = 0;

	public override bool CanTownNPCSpawn() 
	{
            	return Main.player[Main.myPlayer].HasItem(ItemDef.byName["CribMod:BrokenRecordPlayer"].type);	
	}
    }
}