using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using TAPI;
using Terraria;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace CribMod.NPCs
{
	public class HeadofEaterofWorld: ModNPC
	{		
		public override void AI()
		{
			if (Main.rand.Next(2)==0)
			{
				int dust = Dust.NewDust(new Vector2((float) npc.position.X, (float) npc.position.Y), npc.width, npc.height, 18, npc.velocity.X, npc.velocity.Y, 100, default(Color), 1.8f);
				Main.dust[dust].noGravity = false;
			}
		}

        public override string SetName()
        {
            int rand = Main.rand.Next(8);
            string name = "";
            switch(rand)
            {
                case 0: name = "Bob"; break;
                case 1: name = "Pedro"; break;
                case 2: name = "Jekyll"; break;
                case 3: name = "Vermis"; break;
                case 4: name = "Vox Madamme"; break;
                case 5: name = "Mom"; break;
                case 6: name = "Hungry"; break;
                default: name = "Devourer"; break;
            }
            return name;
        }

        public override string SetChat() 
        {
            int rand = Main.rand.Next(10);
            string text = "";
            switch (rand)
            {
                case 0: text = "This is... awkward."; break;
                case 1: text = "What are waiting for!? Finish me!"; break;
                case 2: text = "Are you mocking me!?"; break;
                case 3: text = "See that stick over there? Come poke me with it. It'll be fun..."; break;
                case 4: text = "Reduce me into a burning pile of ashes."; break;
                case 5: text = "Do I... fade into existence now?"; break;
                case 6: text = "My life a fading... my memories blur. Do remind me, what I'm doing here again."; break;
                case 7: text = "And thus I leave this world... with a bitter aftertaste of humanity."; break;
                case 8: text = "Bud-Buddy, is that you?"; break;
               	case 9: text = "!!!"; break;
            }
            return text;
        }

	public override void HitEffect(int hitDirection, double damage, bool isDead)
	{
		if (Main.netMode != 2)
		{
			for (int m = 0; m < (isDead ? 20 : 5); m++)
			{
				int dustID = Dust.NewDust(npc.position, npc.width, npc.height, 18, npc.velocity.X * 0.2f, npc.velocity.Y * 0.2f, 100, default(Color), isDead && m % 2 == 0 ? 3f : 2f);
				if (isDead && m % 2 == 0) { Main.dust[dustID].noGravity = true; }
			}
		}
	}

		public override void PostNPCLoot()    
        	{				
			Main.NewText("It's not too late to quit your game now.", 249, 249, 9); 
            		NPC.NewNPC((int)npc.position.X, (int)npc.position.Y, "CribMod:EATEROFWORLDSHeadBoss", 0);
       		}
	}		
}
