using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using TAPI;
using Terraria;

namespace CribMod.Projectiles
{
    public class VictoryTrainingSpear : ModProjectile
    {
		public override void DamageNPC(NPC npc, int hitDir, ref int damage, ref float knockback, ref bool crit, ref float critMult)
        {
            if ((NPC.AnyNPCs(NPCDef.byName["CribMod:TestDummyBoss"].type)) || (NPC.AnyNPCs(NPCDef.byName["CribMod:CGravelordNitoBoss"].type)) || (NPC.AnyNPCs(NPCDef.byName["CribMod:SwordPlayBoss"].type))) damage *= 5;
        }
		
        public override void AI()
        {
            int DustID = Dust.NewDust(new Vector2(projectile.position.X, projectile.position.Y + 2f), projectile.width, projectile.height, 24, projectile.velocity.X * 0.2f, projectile.velocity.Y * 0.2f, 100, default(Color), 0.5f);
            Main.player[projectile.owner].direction = projectile.direction; //Make's the owner face the direction the spear
            Main.player[projectile.owner].heldProj = projectile.whoAmI;
            Main.player[projectile.owner].itemTime = Main.player[projectile.owner].itemAnimation;
            projectile.position.X = Main.player[projectile.owner].position.X + (float)(Main.player[projectile.owner].width / 2) - (float)(projectile.width / 2);
            projectile.position.Y = Main.player[projectile.owner].position.Y + (float)(Main.player[projectile.owner].height / 2) - (float)(projectile.height / 2);
            projectile.position += projectile.velocity * projectile.ai[0];
            if (projectile.ai[0] == 0f)
            {
                projectile.ai[0] = 3f;
                projectile.netUpdate = true;
            }
            if (Main.player[projectile.owner].itemAnimation < Main.player[projectile.owner].itemAnimationMax / 3)
            {
                projectile.ai[0] -= 2.1f; //How far back it goes
                if (projectile.localAI[0] == 0f && Main.myPlayer == projectile.owner)
                {
                    projectile.localAI[0] = 1f;
                }
            }
            else
            {
                projectile.ai[0] += 6f; //How Far It Goes
            }
            if (Main.player[projectile.owner].itemAnimation == 0)
            {
                projectile.Kill(); //Kills projectile after it is done
            }
            projectile.rotation = (float)Math.Atan2((double)projectile.velocity.Y, (double)projectile.velocity.X) + 2.355f; //Rotates the spear based on where you shoot
            if (projectile.spriteDirection == -1)
            {
                projectile.rotation -= 1.57f;
            }
			
        }
    }
}
